function PSSSetPaths( fast )

%------------------------------------------------------------------------
%   Sets up the paths
%------------------------------------------------------------------------
%   Form:
%   PSSSetPaths
%------------------------------------------------------------------------
%
%   ------
%   Inputs
%   ------
%   None
%
%   -------
%   Outputs
%   -------
%   None
%
%------------------------------------------------------------------------

%------------------------------------------------------------------------
%   Copyright 1999-2003 Princeton Satellite Systems, Inc. 
%   All rights reserved.
%   $Date: 2004/11/01 23:08:42 $ $Revision: 1.3 $
%------------------------------------------------------------------------

pathToToolbox = fileparts(which('PSSSetPaths'));

cd( pathToToolbox )

p = cd;
path( fullfile(p,''), path );

s = dir;

np = {};
for k = 1:length(s)
   if( s(k).isdir & ~strcmp( '..', s(k).name ) & ~strcmp( '.', s(k).name ) & ~strcmp('cvs',lower(s(k).name)) )
      z = fullfile( p, s(k).name, '' );
      np = AddDirectoryToPath( z, np );
   end
end

if( ~isempty(np) )
   addpath(np{:});
end

cd( pathToToolbox );


if( nargin > 0 ) % non-interactive version
   disp('Paths Set!');
else
   q1 = 'Save your additions to the MATLAB path?';
   q2 = 'If you save, you will not have to install these paths again.';
   a = questdlg(sprintf('%s\n%s',q1,q2),'Save Path?','Yes','No','Yes');
   switch lower(a)
      case 'yes'
         if( IsVersionAfter(6.5) )
            savepath;
         else
            path2rc;
         end
         disp(sprintf('\nYour path has been updated and saved.'));
      otherwise
         if( IsVersionAfter(6.5) )
            f = 'savepath';
         else
            f = 'path2rc';
         end
         disp(sprintf('Your path has been updated, but has not been saved.\nType "%s" to save your changes to the path.\n',f));
   end
end


         
%------------------------------------------------------------------------
function np = AddDirectoryToPath( p, np )

s = dir( p );

np{end+1} = p;
for k = 1:length(s)
   if( s(k).isdir & ~strcmp( '..', s(k).name ) & ~strcmp( '.', s(k).name ) & ~strcmp('cvs',lower(s(k).name)) )
      z = fullfile( p, s(k).name, '' );
      if( isempty(findstr( '@', z )) )
         np = AddDirectoryToPath( z, np );
      end
   end
end


%------------------------------------------------------------------------
function t = IsVersionAfter( n )

v = version;
if( str2num(v(1:3)) > n )
  t = 1;
else
  t = 0;
end
